// TwoPullyCalculatorDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MyStuff.h"
#include "TwoPullyCalculator.h"
#include "TwoPullyCalculatorDlg.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTwoPullyCalculatorDlg dialog

CTwoPullyCalculatorDlg::CTwoPullyCalculatorDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTwoPullyCalculatorDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTwoPullyCalculatorDlg)
	m_centerDistance = 0.0;
	m_beltLength = 0.0;
	m_speedRatio = 0.0;
	m_firstPullyDiameter = 0.0;
	m_secondPullyDiameter = 0.0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTwoPullyCalculatorDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTwoPullyCalculatorDlg)
	DDX_Text(pDX, IDC_EDIT1, m_centerDistance);
	DDX_Text(pDX, IDC_EDIT3, m_beltLength);
	DDX_Text(pDX, IDC_EDIT4, m_speedRatio);
	DDX_Text(pDX, IDC_EDIT6, m_firstPullyDiameter);
	DDX_Text(pDX, IDC_EDIT5, m_secondPullyDiameter);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTwoPullyCalculatorDlg, CDialog)
	//{{AFX_MSG_MAP(CTwoPullyCalculatorDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTwoPullyCalculatorDlg message handlers

BOOL CTwoPullyCalculatorDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	OnCancel(); // reset 
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTwoPullyCalculatorDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTwoPullyCalculatorDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTwoPullyCalculatorDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTwoPullyCalculatorDlg::OnCancel() 
{
	m_beltLength = DFLT_BELT_LENGTH;
	m_centerDistance = DFLT_CENTER_DISTANCE;
	m_speedRatio = DFLT_SPEED_RATIO;

	UpdateData(FALSE);
	Calculate();

//	CDialog::OnCancel();
}

void CTwoPullyCalculatorDlg::OnClose() 
{
	DestroyWindow();	
//	CDialog::OnClose();
}

void CTwoPullyCalculatorDlg::OnOK() 
{
	Calculate();
//	CDialog::OnOK();
}

void CTwoPullyCalculatorDlg::Calculate()
{
	UpdateData(TRUE);

	double t1 = 0.0;
	double f1 = 0.0;

	double t2 = 0.0;
	double f2 = fcn(t2);
	double t3 = 0.01;
	double f3 = fcn(t3);

	do
	{
		t1 = t2;
		t2 = t3;
		f1 = f2;
		f2 = f3;

		t3 = (t2 * f1 - t1 * f2) / (f1 - f2);
		f3 = fcn(t3);
	}
	while(::fabs(f3) > .00000001);

	if(m_speedRatio != 1.0)
	{
		m_firstPullyDiameter = ::sin(t3) * 2.0 * m_centerDistance / (1.0 - m_speedRatio);
		m_firstPullyDiameter = ::floor(m_firstPullyDiameter * 1e4) / 1e4;
		m_secondPullyDiameter = m_firstPullyDiameter * m_speedRatio;
		m_secondPullyDiameter = ::floor(m_secondPullyDiameter * 1e4) / 1e4;
	}
	else
	{
		double p = (m_beltLength - 2.0 * m_centerDistance) / PI;
		p = ::floor(p * 1e4) / 1e4;
		m_secondPullyDiameter = m_firstPullyDiameter = p;	
	}

	if(m_firstPullyDiameter <= 0 || m_secondPullyDiameter <= 0)
	{
		AfxMessageBox(_T("Increase distance between pully cneters"));
	}

	UpdateData(FALSE);
}

double CTwoPullyCalculatorDlg::fcn(double theta)
{
	return PI * 0.5 * ::sin(theta) * (1.0 + m_speedRatio) + (1.0 - m_speedRatio) * 
		  (::cos(theta) + theta * ::sin(theta) - m_beltLength * 0.5 / m_centerDistance); 
}
